VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_X(1 To 3) As Single
Private m_Y(1 To 3) As Single

Private m_NumPoints As Integer
'   Y1 = AX1^2 + BX1 + C
'   Y2 = AX2^2 + BX2 + C
'   Y3 = AX3^2 + BX3 + C
'
' Subtracting equation 1 from the other two gives:
'   Y2 - Y1 = A(X2^2 - X1^2) + B(X2-X1)
'   Y3 - Y1 = A(X3^2 - X1^2) + B(X3-X1)
'
' Multiplying the first equation by (X1-X3) and the
' second by (X2-X1) and adding them gives:
'   (Y2-Y1)(X1-X3) = (X1-X3)A(X2^2 - X1^2) + B(X2-X1)(X1-X3)
'   (Y3-Y1)(X2-X1) = (X2-X1)A(X3^2 - X1^2) + B(X3-X1)(X2-X1)
'
' Or
'
'   (Y2-Y1)(X1-X3) + (Y3-Y1)(X2-X1) =
'       A[(X1-X3)(X2^2-X1^2) + (X2-X1)(X3^2-X1^2)]
'
' Solving for A gives:
'   A = [(Y2-Y1)(X1-X3) + (Y3-Y1)(X2-X1)]/[(X1-X3)(X2^2-X1^2) + (X2-X1)(X3^2-X1^2)]
'
' Plugging into the previous equation gives:
'
'   B = [(Y2 - Y1) - A(X2^2 - X1^2)] / (X2-X1)
'
' Plugging into the original equation gives:
'
'   C = Y1 - AX1^2 - BX1
'
' This all looks horrible, but we have the values for
' Y1, Y2, Y3, X1, X2, and X3.
Private Sub FindCurve()
Dim A As Double
Dim B As Double
Dim C As Double
Dim X As Double
Dim Y As Double

    On Error GoTo NoCurve

    ' Calculate A, B, and C.
    A = ((m_Y(2) - m_Y(1)) * (m_X(1) - m_X(3)) + _
         (m_Y(3) - m_Y(1)) * (m_X(2) - m_X(1))) / _
        ((m_X(1) - m_X(3)) * (m_X(2) ^ 2 - m_X(1) ^ 2) + _
         (m_X(2) - m_X(1)) * (m_X(3) ^ 2 - m_X(1) ^ 2))

    B = ((m_Y(2) - m_Y(1)) - A * (m_X(2) ^ 2 - m_X(1) ^ 2)) / (m_X(2) - m_X(1))

    C = m_Y(1) - A * m_X(1) ^ 2 - B * m_X(1)

    ' Draw the curve.
    CurrentX = 0
    Y = C
    If Y > 32000 Then Y = 32000
    If Y < -32000 Then Y = -32000
    CurrentY = Y
    For X = 1 To ScaleWidth
        Y = A * X ^ 2 + B * X + C
        If Y > 32000 Then Y = 32000
        If Y < -32000 Then Y = -32000
        Line -(X, Y)
    Next X

    Me.Caption = _
        Format$(A, "0.0000") & ", " & _
        Format$(B, "0.0000") & ", " & _
        Format$(C, "0.0000")
    Exit Sub

NoCurve:
    MsgBox "No quadratic equation fits these points."
    Exit Sub
End Sub

Private Sub Form_Load()
    ScaleMode = vbPixels
    AutoRedraw = True
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_NumPoints = 3 Then
        Cls
        m_NumPoints = 0
    End If

    m_NumPoints = m_NumPoints + 1
    m_X(m_NumPoints) = X
    m_Y(m_NumPoints) = Y
    Line (X - 2, Y - 2)-Step(4, 4), , BF

    If m_NumPoints = 3 Then FindCurve
End Sub

